import sys

from ardi.driver import drivercore, driverbase

class ardisimdriver:
    def __init__(self):
        self.connected = False
        self.polling = True
    
    def SetAddress(self, addr):
        self.connected = False
    
    def Connect(self):
        self.connected = True
        return True
    
    def Disconnect(self):
        self.connected = False
        
    def Optimise(self):
        print "Optimising Information"
        
    def Poll(self):
        
        for point in self.core.pointlist:
            fname = point.code
            fname = fname.replace(':','_').replace('-','_')
            try:
                #print 'Checking ' + fname
                tfile = open('/var/ardi/sim/' + fname,'r')
                val = tfile.read()
                tfile.close()
            
                self.core.UpdateData(point.code,val)
            except:
                pass

class driverfactory:
    def createinstance(self):
        return ardisimdriver()
            
if __name__ == "__main__":
    sdf = driverfactory()
    base = driverbase.ardidriver()
    base.start(sdf)
    #print str(drivercore)
    #driver = ardisimdriver()
    #core = drivercore.ardicore(driver)
    #core.Launch("localhost",11)