import sys
import random

from ardi.driver import drivercore, driverbase

class ardiranddriver:
    def __init__(self):
        self.connected = False
        self.polling = True
    
    def SetAddress(self, addr):
        self.connected = False
    
    def Connect(self):
        self.connected = True
        return True
    
    def Disconnect(self):
        self.connected = False
        
    def Optimise(self):
        pass
        
    def Poll(self):

        #print 'Polling!'
        for point in self.core.pointlist:
            try:               
                val = random.random()*100
                self.core.UpdateData(point.code,str(val))                
            except:
                pass

class driverfactory:
    def createinstance(self):
        return ardiranddriver()
            
if __name__ == "__main__":
    sdf = driverfactory()
    base = driverbase.ardidriver()
    base.start(sdf)
    