import sys

from ardi.driver import drivercore,driverbase

from pysnmp.entity.rfc3413.oneliner import cmdgen
from pysnmp.proto.rfc1905 import NoSuchObject

class ardisnmpdriver:
    def __init__(self):
        self.connected = False
        self.polling = True
        self.pollinterval = 60
    
    def SetAddress(self, addr):
        self.connected = False
        bits = addr.split(":")
        self.ip = bits[0]
        self.port = int(bits[1])
        self.port = 161
        #self.unit = int(bits[2])
    
    def Connect(self):
        #self.SetAddress(addr)
        self.connected = True
        #self.client = ModbusClient(self.ip, port=self.port)
        #try:
        #    success = self.client.connect()
        #    if success == False:
        #        return False
        #    self.connected = True
        #    return True
        #except:
        #   return False
        return True
        
    def Disconnect(self):
        self.connected = False
        #self.client.close()
        
    def Poll(self):
        queryset = ()
        #print(varBinds[0][1])
        for itm in self.core.pointlist:
            #breakup = itm.address.split('.')
            #print breakup
            queryset = queryset + (itm.address.encode('ascii','ignore'),)
        
        queryset = sorted(queryset)
            
        print queryset
        #queryset = ('1.3.6.1.2.1.1.1.0','1.3.6.1.2.1.1.1.4')
        
        errorIndication, errorStatus, errorIndex, varBinds = cmdgen.CommandGenerator().getCmd(cmdgen.CommunityData('my-agent', 'public', 0), cmdgen.UdpTransportTarget((self.ip, self.port)),*queryset)

        print varBinds
        
        indx = 0
        for itm in self.core.pointlist:
            val = varBinds[indx][1]
            if (type(val) == NoSuchObject):
                self.core.UpdateData(itm.code,"^")
            else:
                self.core.UpdateData(itm.code,str(val))
            indx = indx + 1
            
class driverfactory:
    def createinstance(self):
        return ardisnmpdriver()
            
if __name__ == "__main__":
    sdf = driverfactory()
    base = driverbase.ardidriver()
    base.start(sdf)