import sys
import time

from StringIO import StringIO
from ardi.driver import drivercore,driverbase
import re
import pycurl
     
                            
class ardiwsdriver:
    def __init__(self):
        self.connected = False
        self.polling = True
        self.pollinterval = 30
        self.url = ""
        self.lookuptable = {}

    def SetAddress(self, addr):
        self.connected = False
        bits = addr.split(":")
        self.url = bits[0]
        self.url = self.url.replace("^",":")        
        self.core.logger.warning("Accessing Page: " + self.url);           
    
    def Connect(self):
        try:                        
            self.connected = True        
        except StandardError as err:
            self.core.logger.error(err[1])            
            return False
        except:            
            return False
        return True

    def Optimise(self):        
        pass

    def Disconnect(self):
        self.connected = False    
        
    def Poll(self):
        #try:

            response = StringIO()
            
            c = pycurl.Curl()
            c.setopt(c.URL,self.url)
            c.setopt(c.WRITEFUNCTION,response.write)
            c.setopt(c.TIMEOUT,5)
            c.setopt(c.CONNECTTIMEOUT,5)
            c.perform()
            c.close()
            
            self.GetPoints(response.getvalue())
            pass
        #except:            
        #    self.core.logger.error('Failure')

    def GetPoints(self,content):
        print content
        for itm in self.core.pointlist:
            p = re.compile(itm.address, re.MULTILINE | re.IGNORECASE | re.VERBOSE | re.UNICODE)
            res = re.findall(p, content)
            if res:
                #self.core.logger.info('Loading ' + itm.address + ' = ' + res[0])
                self.core.UpdateData(itm.code,str(res[0]))                     
            else:
                self.core.logger.info('Data Not Available - ' + itm.address)
                self.core.UpdateData(itm.code,str("^"))                     

class driverfactory:
    def createinstance(self):
        return ardiwsdriver()
            
if __name__ == "__main__":
    sdf = driverfactory()
    base = driverbase.ardidriver()
    base.start(sdf)
