<?php
	global $themefolder;
	global $siteroot;
	global $version;
	global $build;
	global $addins;
	
	require_once($_SERVER['DOCUMENT_ROOT'].'/model/user.php');
	$thisuser = new User($_SESSION['userid']);		
	
	if ($thisuser->id != 0)
	{
		$thisuser->Load();
	}
	
	require_once($_SERVER['DOCUMENT_ROOT'].'/model/page.php');
	
	
?><!DOCTYPE html>
<html>
  <head>
    <meta charset="UTF-8">
    <title><?php echo $content['title'];?></title>
    <!-- Tell the browser to be responsive to screen width -->
    <meta content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no" name="viewport">
    <!-- Bootstrap 3.3.5 -->
    <link rel="stylesheet" href="/plugins/bootstrap/css/bootstrap.min.css">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="/plugins/font-awesome/css/font-awesome.min.css">
	<!-- Font Awesome -->
    <link rel="stylesheet" href="/css/shared.css">
    <!-- Ionicons -->
    <link rel="stylesheet" href="/plugins/ionic/ionic.css">
    <!-- jvectormap -->
    <link rel="stylesheet" href="/plugins/jvectormap/jquery-jvectormap-1.2.2.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="<?php echo $themefolder; ?>/css/AdminLTE.min.css">
	<link rel="stylesheet" href="<?php echo $themefolder; ?>/css/ardi.css">
    <!-- AdminLTE Skins. Choose a skin from the css/skins
         folder instead of downloading all of them to reduce the load. -->
    <link rel="stylesheet" href="<?php echo $themefolder; ?>/css/skins/_all-skins.min.css">

    <!-- HTML5 Shim and Respond.js IE8 support of HTML5 elements and media queries -->
    <!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
    <!--[if lt IE 9]>
        <script src="https://oss.maxcdn.com/html5shiv/3.7.3/html5shiv.min.js"></script>
        <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->
	<link rel="favicon" href="/images/favicon.ico">
	<link rel="apple-touch-icon" sizes="72x72" href="/images/72x72.png">
	<link rel="apple-touch-icon" sizes="114x114" href="/images/114x114.png">
	<link rel="apple-touch-icon" sizes="128x128" href="/images/120x120.png">
	<link rel="apple-touch-icon" sizes="144x144" href="/images/144x144.png">
	<link rel="apple-touch-icon" sizes="180x180" href="/images/180x180.png">
	<link rel="icon" type="image/png" sizes="192x192"  href="/images/192x192.png">
	<link rel="icon" type="image/png" sizes="32x32" href="/images/32x32.png">
	<link rel="icon" type="image/png" sizes="96x96" href="/images/96x96.png">
	<link rel="icon" type="image/png" sizes="16x16" href="/images/16x16.png">
	<meta name="msapplication-TileColor" content="#ffffff">
	<meta name="msapplication-TileImage" content="/images/114x114.png">
	<meta name="theme-color" content="#ffffff">
	
	<?php if (isset($content['head'])) echo $content['head'];?>
  </head>
  <body class="skin-blue sidebar-mini">
    <div class="wrapper">

      <header class="main-header">

        <!-- Logo -->
        <a href="<?php echo $siteroot; ?>" class="logo">
          <!-- mini logo for sidebar mini 50x50 pixels -->
          <span class="logo-mini">ARDI</span>
          <!-- logo for regular state and mobile devices -->
          <span class="logo-lg">ARDI</span>
        </a>

        <!-- Header Navbar: style can be found in header.less -->
        <nav class="navbar navbar-static-top" role="navigation">
          <!-- Sidebar toggle button-->
          <a href="#" class="sidebar-toggle" data-toggle="offcanvas" role="button">
            <span class="sr-only">Toggle navigation</span>
          </a>
          <!-- Navbar Right Menu -->
          <div class="navbar-custom-menu">
            <ul class="nav navbar-nav">
              <!-- Messages: style can be found in dropdown.less-->
              <li class="dropdown messages-menu">
                <a href="#" class="dropdown-toggle" data-toggle="dropdown">
                  <i class="fa fa-thumb-tack"></i>
                  <!--<span class="label label-success">4</span>-->
                </a>
                <ul class="dropdown-menu">
                  <li class="header">You have no pinned values</li>
                  <li>
                    <!-- inner menu: contains the actual data -->
                    <!--<ul class="menu">
                      <li>
                        <a href="#">
                          <div class="pull-left">
                            <img src="dist/img/user2-160x160.jpg" class="img-circle" alt="User Image">
                          </div>
                          <h4>
                            Support Team
                            <small><i class="fa fa-clock-o"></i> 5 mins</small>
                          </h4>
                          <p>Why not buy a new awesome theme?</p>
                        </a>
                      </li>
                      </ul>
					  </li>-->
                  <li class="footer"><a href="#">Clear Pins</a></li>
                </ul>
              </li><?php
					?> 
					
              <!-- Notifications: style can be found in dropdown.less -->
              <li class="dropdown notifications-menu">
                <a href="#" class="dropdown-toggle" data-toggle="dropdown">
                  <i class="fa fa-bell-o"></i>
                  <?php if (count($alist) > 0) { ?><span class="label label-warning"><?php echo count($alist); ?></span><?php }; ?>
                </a>
                <ul class="dropdown-menu">
				
                  <li class="header"><?php 
				  if (count($alist) == 0) 
						echo 'You have no active alerts';
					else
						echo 'There are '.count($alist).' active alerts';?>
				  </li>
                  <li>
				  <?php 
					if ($any == true) { ?>
                    <!-- inner menu: contains the actual data -->
                    <ul class="menu">
						<?php foreach($alist as $a) { ?>
                      <li>
                        <a href="<?php echo $siteroot; ?><?php if ($a['id'] > 0) { echo '/alert/'.$a['id']; } else { echo '/info/license'; }; ?>">
                          <i class="fa fa-bell-o text-aqua"></i> <?php echo $a['name']; ?>
                        </a>
                      </li>
					  <?php }; ?>
                    </ul>
					<?php }; ?>
                  </li>
                  <li class="footer"><a href="<?php echo $siteroot;?>/alerts">View all</a></li>
                </ul>
              </li>
              <!-- User Account: style can be found in dropdown.less -->			  
<?php		  if (($thisuser->id == "") && ($thisuser->id == 0))
			  {?>
			  <li class="dropdown user user-menu">
                <a href="#" class="dropdown-toggle" data-toggle="dropdown">
                  
                  <span class="hidden-xs">Login</span>
                </a>
                <ul class="dropdown-menu">
                  				  			
					  <li class="user-header"> 
						<label>Username</label><br/>
						<input type="text" name="login_username"/><br/><br/>
						<label>Password</label><br/>
						<input type="password" name="login_password"/>
					  </li>
					  
					  
					  <!-- Menu Footer-->
					  <li class="user-footer">		
						<div class="pull-left">
						  <a href="#" class="btn btn-default btn-flat">Cancel</a>
						</div>					  
						<div class="pull-right">
						  <button class="btn btn-default btn-flat">Login to ARDI</button>						  
						</div>
					  </li>					
						
							<!--<table>
								<tr><td><label>Username</label></td><td><input type="text" name="login_username"/>	</td></tr>
								<tr><td><label>Password</label></td><td><input type="password" name="login_password"/></td></tr>
							</table>-->
							
													
												                  
                                    
                </ul>				
              </li>
<?php		  }
			  else
			  {?>
              <li class="dropdown user user-menu">
                <a href="#" class="dropdown-toggle" data-toggle="dropdown">
				<?php
						$username
				?>
                  
                  <span class="hidden-xs"><?php echo $username; ?></span>
                </a>
                <ul class="dropdown-menu">
                  <!-- User image -->
                  <li class="user-header">                    
                    <p>
                      <?php
						echo $username;?>
                      <small><?php $userlevel;?></small>
                    </p>
                  </li> 
                  
                  <!-- Menu Footer-->
                  <li class="user-footer">
				   <?php
				  if ($thisuser->id > 0) {?>
                    <div class="pull-left">
                      <a href="<?php echo $siteroot;?>/user/settings" class="btn btn-default btn-flat">Settings</a>
                    </div>
				<?php }; ?>
                    <div class="pull-right">
					<?php if (($thisuser->id == "") && ($thisuser->id == 0)) {?>
                      <a href="<?php echo $siteroot; ?>/login" class="btn btn-default btn-flat">Login</a>
					  <?php } else { 
						if ($username == "Guest") { ?>
						<a href="<?php echo $siteroot; ?>/login" class="btn btn-default btn-flat">Login</a><?php
						}
						else {?>
					   <a href="<?php echo $siteroot; ?>/user/logout" class="btn btn-default btn-flat">Sign Out</a>
					  <?php }; }; ?>
                    </div>
                  </li>
				  
                </ul>
              </li>
<?php 		  }; ?>
              <!-- Control Sidebar Toggle Button 
              <li>
                <a href="#" data-toggle="control-sidebar"><i class="fa fa-gears"></i></a>
              </li>-->
            </ul>
          </div>

        </nav>
      </header>
      <!-- Left side column. contains the logo and sidebar -->
      <aside class="main-sidebar">
        <!-- sidebar: style can be found in sidebar.less -->
        <section class="sidebar">
          <!-- Sidebar user panel -->
          
          <!-- search form -->
          <form action="<?php echo $siteroot;?>/views/search" method="get" class="sidebar-form">
            <div class="input-group">
              <input type="text" name="q" class="form-control" id="sidebarsearch" placeholder="Search...">
              <span class="input-group-btn">
                <button type="submit" name="search" id="search-btn" class="btn btn-flat"><i class="fa fa-search"></i></button>
              </span>
            </div>
          </form>
          <!-- /.search form -->
          <!-- sidebar menu: : style can be found in sidebar.less -->
          <ul class="sidebar-menu">
            <li class="header">MAIN NAVIGATION</li>
			
			<?php 
			if ((isset($sitelist)) && (count($sitelist) > 1))
			{
				?>
				
			<li class="treeview">
              <a href="<?php $siteroot; ?>/">
                <i class="fa fa-plus-circle"></i>
                <span><?php echo $sitenames;?></span>                
              </a>
              <ul class="treeview-menu">
			  <?php 
			  foreach($sitelist as $k => $v)
			  {
				echo '<li><a href="/s/'.$k.'"><i class="fa fa-circle-o"></i> '.$v['name'].'</a></li>';
			  }?>
                
            		
              </ul>
            </li>
			
			<?php } ?>
            <li class="treeview">
              <a href="<?php echo $siteroot; ?>/">
                <i class="fa fa-search"></i> <span>Find Assets</span>
              </a>
            </li>
            <li class="treeview">
              <a href="#">
                <i class="fa fa-plus-circle"></i>
                <span>Browse</span>                
              </a>
              <ul class="treeview-menu"><?php
						$query = $db->query("SELECT id,name,rootasset FROM relationships WHERE rootasset > 0 ORDER BY name ");
									
						foreach($navrels as $row)
						{
						?>
				<li><a href="<?php echo $siteroot; ?>/diagram/<?php echo $row['rootasset'];?>/<?php echo $row['id']; ?>"><?php echo $row['name']; ?></a></li>
		<?php			}?>
                
              </ul>
            </li>  			
<?php if (isset($content['sidebar'])) echo $content['sidebar'];?>	
			<li><a href="<?php echo $siteroot; ?>/alerts"<?php if ((isset($anyalerts)) && ($anyalerts == true)) echo ' style="color: yellow;"'; ?>><i class="fa fa-bell"></i> <span>Alerts</span></a></li> 	
<?php /*if (true) { ?>
		<li><a href="http://www.optrix.com.au/clients"><i class="fa fa-download"></i> <span>Clients</span></a>
				<ul class="treeview-menu">
					<li><a href="http://www.optrix.com.au/clients/ar"><i class="fa fa-circle-o"></i> Augmented Reality</a></li>
					<li><a href="http://www.optrix.com.au/clients/ve?forversion=<?php echo urlencode($version);?>"><i class="fa fa-circle-o"></i> Virtual Environment</a></li>
				</ul>
			</li>
<?php };*/ 

	if ($eventsavail == true) {
	?>
<li><a href="<?php echo $siteroot; ?>/events"><i class="fa fa-clock-o"></i>Events</a></li>
<?php 		
	};

	/*global $installfolder;
	$folders = glob($installfolder.'/addons/*');
	foreach($folders as $fld)
	{
		if (file_exists($fld.'/info.inc'))
		{
			unset($addon);
			include($fld.'/info.inc');
			if (!isset($addon)) continue;
			$pth = pathinfo($fld,PATHINFO_FILENAME);
			if (isset($addon))
			{
				if (isset($addon['menu'])) {?>
					<li><a href="<?php echo $siteroot; ?>/<?php echo $pth;?>"><i class="fa fa-<?php echo $addon['icon'];?>"></i> <span><?php echo $addon['name'];?></span></a>
					<ul class="treeview-menu"><?php
					foreach($addon['menu'] as $mnu)
					{
						$url = $mnu['href'];

						echo '<li><a href="'.$url.'"><i class="fa fa-circle-o"></i> '.$mnu['name'].'</a></li>';
					}
					?></ul><?php
				}
			}
		}
	}*/
	//print_r($addins->alist);
	if (isset($addins->alist))
	{
		foreach($addins->alist as $add)
		{
			if (is_array($add->menu))
			{
				//foreach($add->menu as $v)
				//{
					//echo 'Working On...'.$add->menuname.': ';
					//print_r($add->menu);
					if (count($add->menu) > 0) 
					{
						if (count($add->menu) == 1)
						{ ?>
							<li><a href="<?php echo $add->menu[0]['href'];?>"><i class="fa fa-<?php echo $add->menuicon;?>"></i> <span><?php echo $add->menuname;?></span></a></li><?php
						}
						else
						{
					?>
						<li><a href="#"><i class="fa fa-<?php echo $add->menuicon;?>"></i> <span><?php echo $add->menuname;?></span></a>
						<ul class="treeview-menu"><?php
						foreach($add->menu as $n)
						{
							$url = $n['href'];

							echo '<li><a href="'.$url.'"><i class="fa fa-circle-o"></i> '.$n['name'].'</a></li>';
						}
						?>
						</ul></li>
						<?php
						}
					}
				//}
			}
		}
	}
	
	if (CheckAdmin()) { ?>	
			<li><a href="<?php echo $siteroot; ?>/tools"><i class="fa fa-wrench"></i> <span>Tools</span></a>
				<ul class="treeview-menu">
					<li><a href="<?php echo $siteroot; ?>/tools/import"><i class="fa fa-circle-o"></i> Import Tools</a></li>
					<li><a href="<?php echo $siteroot; ?>/reports"><i class="fa fa-circle-o"></i> Reports</a></li>
				</ul>
				
			</li>			
			<li><a href="<?php echo $siteroot; ?>/admin"><i class="fa fa-wrench"></i> <span>Administration</span></a></li> 	
<?php }; ?>
<?php 
	  global $installfolder;
	  if (file_exists($installfolder.'/docs')) { ?>
            <li><a href="/docs"><i class="fa fa-book"></i> <span>Documentation</span></a></li>      
<?php }; ?>			
          </ul>
        </section>
        <!-- /.sidebar -->
      </aside>

      <!-- Content Wrapper. Contains page content -->
      <div class="content-wrapper">
        <!-- Content Header (Page header) -->		
    
        <?php echo $content['']; ?>
      </div><!-- /.content-wrapper -->

      <footer class="main-footer">
        <div class="pull-right hidden-xs">
          <b>Version</b> <?php echo $version; ?> - Build <a href="<?php echo $siteroot;?>/info/version"><?php echo $build; ?></a>
        </div>
        <strong>Copyright &copy; 2014-2015 <a href="http://www.optrix.com.au">Optrix Pty. Ltd.</a>.</strong> All rights reserved.
      </footer>

    </div><!-- ./wrapper -->

    <!-- jQuery 2.1.4 -->
    <script src="/plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 3.3.5 -->
    <script src="/plugins/bootstrap/js/bootstrap.min.js"></script>
    <!-- FastClick -->
    <script src="/plugins/fastclick/fastclick.min.js"></script>
    <!-- AdminLTE App -->
    <script src="<?php echo $themefolder; ?>/js/app.min.js"></script>
    <!-- Sparkline -->
    <script src="/plugins/sparkline/jquery.sparkline.min.js"></script>
    <!-- jvectormap -->
    <script src="/plugins/jvectormap/jquery-jvectormap-1.2.2.min.js"></script>
    <script src="/plugins/jvectormap/jquery-jvectormap-world-mill-en.js"></script>
    <!-- SlimScroll 1.3.0 -->
    <script src="/plugins/slimScroll/jquery.slimscroll.min.js"></script>
    <!-- ChartJS 1.0.1 -->
    <script src="/plugins/chartjs/Chart.min.js"></script>
    <!-- AdminLTE dashboard demo (This is only for demo purposes) -->   

	<?php if (isset($content['addscripts'])) echo $content['addscripts']; ?>
	
	<script>
		$(function() {
			<?php if (isset($content['onload'])) echo $content['onload']; ?>
		});
	</script>
    
  </body>
</html>
